#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>

static void write_int(int fd, int v)
{
  char b[4];
  b[0] = v & 255;
  b[1] = (v >>  8) & 255;
  b[2] = (v >> 16) & 255;
  b[3] = (v >> 24) & 255;
  if (write(fd, b, 4) != 4) exit(1);
}

void *user_input(void *_)
{
  int fd = *(int *)_;

  while (1) {
    int id, vol;
    if (scanf("%d %d", &id, &vol) != 2) exit(1);
    write_int(fd, 1);
    write_int(fd, id);
    write_int(fd, vol);
  }
}

void new_thread(void *(*f)(void *), void *data)
{
  pthread_t t;
  pthread_attr_t att;

  if (pthread_attr_init(&att))
    { fprintf(stderr, "pthread_attr_init err\n"); exit(1); }
  if (pthread_attr_setdetachstate(&att, PTHREAD_CREATE_DETACHED))
    { fprintf(stderr, "pthread_attr_setdetachstate err\n"); exit(1); }
  if (pthread_attr_setstacksize(&att, 10000000))
    { fprintf(stderr, "pthread_attr_setstacksize err\n"); exit(1); }
  if (pthread_create(&t, &att, f, data))
    { fprintf(stderr, "pthread_create err\n"); exit(1); }
  if (pthread_attr_destroy(&att))
    { fprintf(stderr, "pthread_attr_destroy err\n"); exit(1); }
}

int get_int(int fd)
{
  char b[4];
  int ret = read(fd, b, 4);
  if (ret != 4) exit(1);
  return ( b[0] & 255) |
         ((b[1] & 255) <<  8) |
         ((b[2] & 255) << 16) |
         ((b[3] & 255) << 24);
}

int main(void)
{
  struct sockaddr_un addr;
  int fd;
  char msg[] = { 0x12, 0x34, 0x56, 0x78,
                 0xff, 0xff, 0xff, 0xff,
                 0x34, 0x56, 0x78, 0x90,
                 0x45, 0x67, 0x89, 0x01,
                 0x56, 0x78, 0x90, 0x12, };

  fd=socket(AF_UNIX,SOCK_STREAM,0); if(fd==-1){perror("socket");return 1;}

  addr.sun_family = AF_UNIX;
  addr.sun_path[0] = 0;
  strcat(addr.sun_path, "/tmp/pulseaudionano.socket");

  if (connect(fd, (struct sockaddr *)&addr, sizeof(addr)) == -1)
    { perror("connect"); return 1; }

  if (write(fd, msg, sizeof(msg)) != sizeof(msg))
    { perror("write"); return 1; }

  new_thread(user_input, &fd);

  while (1) {
    int count;
    int i;
    int id;
    int vol;
    count = get_int(fd);
    printf("%d\n", count);
    for (i = 0; i < count; i++) {
      id = get_int(fd);
      vol = get_int(fd);
      printf("  %d %d\n", id, vol);
    }
  }
  printf("done\n");
  return 0;
}
